extends Control

#turns
var turn = 1
var is_spector_turn = true
#actions
enum Points {GREED,ENVY,LUST,LAZY}
var actionpoints = [1,3,1,2]#0=greed,1=envy,2=lust,3=lazy

var CIA_power = 40

var currentmove = {}
var moves = [
#	{
#		"use":NodeA,
#		"point":Points.GREED,
#		"attack":NodeB,
#	}
]

signal endturn
signal on_win
signal on_lose

## COMBAT
func start_move(NodeA):#1.start a move
	if(!currentmove.has("use")):
		currentmove["use"] = NodeA
		$feedback.text = NodeA.name

func select_move_method(what):#2.what point will you use
	if(currentmove.has("use")):
		if(actionpoints[what]>0):
			currentmove["point"] = what
			$feedback.text = currentmove["use"].name+" with "+Points.keys()[what]

func end_move(NodeB):#selected a target with the current move
	if(currentmove.has("point")):
		if(currentmove["use"].connected_bios.has(NodeB.name)):
			currentmove["attack"] = NodeB
			moves.append(currentmove)
			var multi = 1
			if($Violentmode.pressed==true):
				multi=2
				moves.append(currentmove)#let's do the move again
			actionpoints[currentmove["point"]]-=(1*multi)
			match(currentmove["point"]):#There has got to be a better way to do this
				Points.GREED:
					$HBoxContainer/greed.text = "Greed: "+str(actionpoints[currentmove["point"]])
				Points.LUST:
					$HBoxContainer/lust.text = "Lust: "+str(actionpoints[currentmove["point"]])
				Points.LAZY:
					$HBoxContainer/lazy.text = "Lazy: "+str(actionpoints[currentmove["point"]])
				Points.ENVY:
					$HBoxContainer/envy.text = "Envy: "+str(actionpoints[currentmove["point"]])
	currentmove = {}
	$feedback.text = ""

## TURNS
func end_turn():#ended the turn
	#Play moves
	for i in moves:
		i["attack"].add_control(i["use"].influence,i["point"])
		$action.text = "\n"+i["use"].name+" Attacks "+i["attack"].name+" With "+str(Points.keys()[i["point"]])
	#play enemy
	calc_CIA()
	#next turn
	moves = []
	turn+=1
	$Turn.text = "Spector's Turn: "+str(turn)
	emit_signal("endturn")

func calc_CIA():#I was going to have an AI, but given my experience I think I'll just have a simple algorithm.
	#But if I have the time, I could make this more complicated.
	var levelnode = get_tree().root.get_child(1)
	if(is_instance_valid(levelnode)):
		for node in levelnode.get_children():
			if(node.is_class("VBoxContainer")):
				if(node.get_node("use").text == "Attack"):#The CIA can use these
					for con_bio in node.connected_bios:
						if(levelnode.has_node(con_bio)):
							levelnode.get_node(con_bio).add_control(-node.influence,node.generate)

func add_action_points(what,val):#Add action points
	actionpoints[what] += val
	match(what):
			Points.GREED:
				$HBoxContainer/greed.text = "Greed: "+str(actionpoints[what])
			Points.LUST:
				$HBoxContainer/lust.text = "Lust: "+str(actionpoints[what])
			Points.LAZY:
				$HBoxContainer/lazy.text = "Lazy: "+str(actionpoints[what])
			Points.ENVY:
				$HBoxContainer/envy.text = "Envy: "+str(actionpoints[what])

## RESET
func reset():#Resets all variables
	actionpoints = [1,3,1,2]
	CIA_power = 40
	turn = 1
	$Turn.text = "Spector's Turn: "+str(turn)
	$HBoxContainer/envy.text = "Envy: "+str(actionpoints[1])
	$HBoxContainer/greed.text = "Greed: "+str(actionpoints[0])
	$HBoxContainer/lazy.text = "Lazy: "+str(actionpoints[3])
	$HBoxContainer/lust.text = "Lust: "+str(actionpoints[2])

func gameover():#WHen you lose
	$losetext.visible = true
	get_tree().create_timer(3).connect("timeout",get_tree(),"change_scene",["res://GUI/main.tscn"])
	get_tree().create_timer(3).connect("timeout",$losetext,"set_visible",[false])
	emit_signal("on_lose")
	reset()

func win():#You won
	$wintext.visible = true
	var sceneto = "res://GUI/main.tscn"
	var levelnode = get_tree().root.get_child(1)
	if(is_instance_valid(levelnode)):
		match(levelnode.name):
			"TutorialLevel":
				sceneto = "res://levels/Office.tscn"
			"Office":
				sceneto = "res://levels/school.tscn"
			"School":
				sceneto = "res://levels/church.tscn"
			"church":
				sceneto = "res://levels/collage.tscn"
			"collage":
				sceneto = "res://levels/organization.tscn"
			"organization":
				sceneto = "res://levels/government.tscn"
			"government":
				sceneto = "res://levels/CIAheadquarters.tscn"
			"CIAHQ":
				sceneto = "res://GUI/winscreen.tscn"
	get_tree().create_timer(3).connect("timeout",get_tree(),"change_scene",[sceneto])
	get_tree().create_timer(3).connect("timeout",$wintext,"set_visible",[false])
	emit_signal("on_win")
	reset()