extends VBoxContainer

enum BioType {
	NORMAL,
	START,
	OBJECTIVE
}
export (BioType) var bio = BioType.NORMAL
enum Points {
	GREED,
	ENVY,
	LUST,
	LAZY
}
export (Points) var generate = Points.ENVY
export (Points) var weak_to = Points.GREED
export (int,0,100) var influence = 35
export(int,0,100) var control = 0#100 = you control this
export(Array,String) var connected_bios = []#What bios this bio can attack/be attack by.

## USE
func _on_use_pressed():
	if($use.text == "Use"):
		$"/root/HUD".start_move(self)
	else:
		$"/root/HUD".end_move(self)

## ON TURN
func on_turn():#When a turn changes
	if($use.text == "Use"):
		$"/root/HUD".add_action_points(generate,1)

## Action
func add_control(p,kind):#Add control points to this bio
	var multi = 1
	if(kind == weak_to):
		multi = 3
	control = clamp(control+(p*multi),0,100)
	$hp.text = "Control: "+ str(control)
	if(control==100):
		claim()
	elif(control==0):
		lost()

func claim():#when you have the bio
	$use.text = "Use"
	modulate = Color.white
	if(bio==BioType.OBJECTIVE):#You have obtained the objective
		$"/root/HUD".win()

func lost():#when you lose this bio
	$use.text = "Attack"
	modulate = Color.gray
	if(bio==BioType.START):#Uh you took a step back my comrade
		$"/root/HUD".gameover()

## MAIN
func _ready():
	$type.text = BioType.keys()[bio]
	$cia.text = "Influence: "+str(influence) #I realized the redundancy of having two health bars
	if(bio==BioType.START):
		control = 100
		claim()
	$hp.text = "Control: "+str(control)
	var connections = [
		$"/root/HUD".connect("endturn",self,"on_turn")
	]
	print_debug(connections)